// Fill out your copyright notice in the Description page of Project Settings.

#include "ViveportSDKPrivatePCH.h"
#include "ViveportSubscription.h"
#include "viveport_api.h"
#include "viveport_ext_api.h"

void IsSubscriptionReadyHandler(int nResult);

static ViveportApiStatus* is_ready_callback;

int UViveportSubscription::IsReady(ViveportApiStatus* callback)
{
#if PLATFORM_WINDOWS
    if (FViveportSDKModule::IsAvailable())
    {
        is_ready_callback = callback;

        return ViveportDlc()->IsReady(IsSubscriptionReadyHandler);
    }
#endif
    return 0;
}

bool UViveportSubscription::IsSubscribed(bool &isViveportClientNeedToUpdate)
{
#if PLATFORM_WINDOWS
    if (FViveportSDKModule::IsAvailable())
    {
        int errorCode = ViveportDlc()->IsSubscribed();
        
        if (errorCode == -1)
        {
            isViveportClientNeedToUpdate = true;
            return false;
        }
        else if (errorCode == 0)
        {
            isViveportClientNeedToUpdate = false;
            return true;
        }
        isViveportClientNeedToUpdate = false;
        return false;
    }
#endif
    return 1;
}

void IsSubscriptionReadyHandler(int nResult)
{
    return nResult == 0 ?
        is_ready_callback->OnSuccess() : 
        is_ready_callback->OnFailure(nResult);
}